Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement.DataAccess/3.3/UserManagement.dbml.layout
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement.DataAccess/3.3/UserManagement.dbml.layout	(revision 6810)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement.DataAccess/3.3/UserManagement.dbml.layout	(revision 6810)
@@ -0,0 +1,78 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<ordesignerObjectsDiagram dslVersion="1.0.0.0" absoluteBounds="0, 0, 11, 8.5" name="UserManagement">
+  <DataContextMoniker Name="/UserManagementDataContext" />
+  <nestedChildShapes>
+    <classShape Id="bfae4898-c14d-4e2a-b390-59a7329f88fc" absoluteBounds="0.5, 0.5, 2, 1.5785953776041666">
+      <DataClassMoniker Name="/UserManagementDataContext/aspnet_Application" />
+      <nestedChildShapes>
+        <elementListCompartment Id="66438679-9d23-4f10-96a5-38fea3bc2254" absoluteBounds="0.51500000000000012, 0.96, 1.9700000000000002, 1.0185953776041665" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
+    <classShape Id="dce51ff4-29ce-4e3a-83ea-54f2b2133c39" absoluteBounds="6.625, 0.5, 2, 4.8477197265625">
+      <DataClassMoniker Name="/UserManagementDataContext/aspnet_Membership" />
+      <nestedChildShapes>
+        <elementListCompartment Id="c41f1dfb-2b00-4e69-83d8-954077e4041d" absoluteBounds="6.6400000000000006, 0.96, 1.9700000000000002, 4.2877197265625" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
+    <associationConnector edgePoints="[(2.5 : 1.04509951660156); (6.625 : 1.04509951660156)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/UserManagementDataContext/aspnet_Application/aspnet_Application_aspnet_Membership" />
+      <nodes>
+        <classShapeMoniker Id="bfae4898-c14d-4e2a-b390-59a7329f88fc" />
+        <classShapeMoniker Id="dce51ff4-29ce-4e3a-83ea-54f2b2133c39" />
+      </nodes>
+    </associationConnector>
+    <classShape Id="cb8a41cf-1351-439a-b65c-4437180e49da" absoluteBounds="0.5, 2.5, 2, 1.7708968098958331">
+      <DataClassMoniker Name="/UserManagementDataContext/aspnet_Role" />
+      <nestedChildShapes>
+        <elementListCompartment Id="73f24880-cefd-4c1b-a902-b47e159f2be9" absoluteBounds="0.51500000000000012, 2.96, 1.9700000000000002, 1.2108968098958333" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
+    <associationConnector edgePoints="[(1.5 : 2.07859537760417); (1.5 : 2.5)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/UserManagementDataContext/aspnet_Application/aspnet_Application_aspnet_Role" />
+      <nodes>
+        <classShapeMoniker Id="bfae4898-c14d-4e2a-b390-59a7329f88fc" />
+        <classShapeMoniker Id="cb8a41cf-1351-439a-b65c-4437180e49da" />
+      </nodes>
+    </associationConnector>
+    <classShape Id="014ea058-70d5-4a65-9239-8bc3bff72ba2" absoluteBounds="2.25, 5.125, 2, 1.1939925130208333">
+      <DataClassMoniker Name="/UserManagementDataContext/aspnet_UsersInRole" />
+      <nestedChildShapes>
+        <elementListCompartment Id="2c3f6ef1-9b30-4e95-b26c-7d56e3f35263" absoluteBounds="2.2649999999999997, 5.585, 1.9700000000000002, 0.63399251302083326" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
+    <associationConnector edgePoints="[(1.3749995 : 4.27089680989583); (1.3749995 : 5.72199625651042); (2.25 : 5.72199625651042)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/UserManagementDataContext/aspnet_Role/aspnet_Role_aspnet_UsersInRole" />
+      <nodes>
+        <classShapeMoniker Id="cb8a41cf-1351-439a-b65c-4437180e49da" />
+        <classShapeMoniker Id="014ea058-70d5-4a65-9239-8bc3bff72ba2" />
+      </nodes>
+    </associationConnector>
+    <classShape Id="64fd2372-ad93-4552-8a0d-0aeb933ac7ba" absoluteBounds="3.75, 2.5, 2, 2.1554996744791666">
+      <DataClassMoniker Name="/UserManagementDataContext/aspnet_User" />
+      <nestedChildShapes>
+        <elementListCompartment Id="9491033f-9589-4746-b0fb-3b1a2f95de3b" absoluteBounds="3.7649999999999997, 2.96, 1.9700000000000002, 1.5954996744791665" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
+    <associationConnector edgePoints="[(5.75 : 3.57774983723958); (6.625 : 3.57774983723958)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/UserManagementDataContext/aspnet_User/aspnet_User_aspnet_Membership" />
+      <nodes>
+        <classShapeMoniker Id="64fd2372-ad93-4552-8a0d-0aeb933ac7ba" />
+        <classShapeMoniker Id="dce51ff4-29ce-4e3a-83ea-54f2b2133c39" />
+      </nodes>
+    </associationConnector>
+    <associationConnector edgePoints="[(4 : 4.65549967447917); (4 : 5.125)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/UserManagementDataContext/aspnet_User/aspnet_User_aspnet_UsersInRole" />
+      <nodes>
+        <classShapeMoniker Id="64fd2372-ad93-4552-8a0d-0aeb933ac7ba" />
+        <classShapeMoniker Id="014ea058-70d5-4a65-9239-8bc3bff72ba2" />
+      </nodes>
+    </associationConnector>
+    <associationConnector edgePoints="[(2.5 : 1.71519903320312); (4.75 : 1.71519903320312); (4.75 : 2.5)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/UserManagementDataContext/aspnet_Application/aspnet_Application_aspnet_User" />
+      <nodes>
+        <classShapeMoniker Id="bfae4898-c14d-4e2a-b390-59a7329f88fc" />
+        <classShapeMoniker Id="64fd2372-ad93-4552-8a0d-0aeb933ac7ba" />
+      </nodes>
+    </associationConnector>
+  </nestedChildShapes>
+</ordesignerObjectsDiagram>
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/Convert.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/Convert.cs	(revision 6810)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/Convert.cs	(revision 6810)
@@ -0,0 +1,84 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using AN = System.Web.Security;
+using DA = HeuristicLab.Services.UserManagement.DataAccess;
+using DT = HeuristicLab.Services.UserManagement.DataTransfer;
+
+namespace HeuristicLab.Services.UserManagement {
+  public static class Convert {
+
+    #region Application
+    public static DT.Application ToDto(DA.aspnet_Application source) {
+      return new DT.Application() {
+        Id = source.ApplicationId,
+        Description = source.Description,
+        Name = source.ApplicationName
+      };
+    }
+
+    public static DA.aspnet_Application ToEntity(DT.Application source) {
+      return new DA.aspnet_Application() {
+        ApplicationId = source.Id,
+        ApplicationName = source.Name,
+        Description = source.Description
+      };
+    }
+    #endregion
+
+    #region User
+    public static DT.User ToDto(AN.MembershipUser source) {
+      return new DT.User() {
+        Comment = source.Comment,
+        LastActivityDate = source.LastActivityDate,
+        CreationDate = source.CreationDate,
+        Email = source.Email,
+        IsApproved = source.IsApproved,
+        IsLockedOut = source.IsLockedOut,
+        IsOnline = source.IsOnline,
+        LastLockoutDate = source.LastLockoutDate,
+        LastLoginDate = source.LastLockoutDate,
+        LastPasswordChangedDate = source.LastPasswordChangedDate,
+        PasswordQuestion = source.PasswordQuestion,
+        ProviderName = source.ProviderName,
+        ProviderUserKey = source.ProviderUserKey,
+        UserName = source.UserName
+      };
+    }
+
+    public static AN.MembershipUser ToEntity(DT.User source) {
+      return new AN.MembershipUser(source.ProviderName, source.UserName, source.ProviderUserKey, source.Email, source.PasswordQuestion, source.Comment, source.IsApproved, source.IsLockedOut, source.CreationDate, source.LastLoginDate, source.LastActivityDate, source.LastPasswordChangedDate, source.LastLockoutDate);
+    }
+    #endregion
+
+    #region Role
+    public static DT.Role ToDto(string source) {
+      return new DT.Role() {
+        RoleName = source
+      };
+    }
+
+    public static string ToEntity(DT.Role source) {
+      return source.RoleName;
+    }
+    #endregion
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Application.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Application.cs	(revision 6810)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Application.cs	(revision 6810)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab 
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * 
+ * This file is part of HeuristicLab. 
+ * 
+ * HeuristicLab is free software: you can redistribute it and/or modify 
+ * it under the terms of the GNU General Public License as published by 
+ * the Free Software Foundation, either version 3 of the License, or 
+ * (at your option) any later version. 
+ * 
+ * HeuristicLab is distributed in the hope that it will be useful, 
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * GNU General Public License for more details. 
+ * 
+ * You should have received a copy of the GNU General Public License 
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>. 
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.UserManagement.DataTransfer {
+  [DataContract]
+  public class Application : UserManagementItem {
+
+    [DataMember]
+    public Guid Id { get; set; }
+
+    [DataMember]
+    public string Name { get; set; }
+
+    [DataMember]
+    public string Description { get; set; }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Membership.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Membership.cs	(revision 6810)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Membership.cs	(revision 6810)
@@ -0,0 +1,88 @@
+﻿#region License Information
+/* HeuristicLab 
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * 
+ * This file is part of HeuristicLab. 
+ * 
+ * HeuristicLab is free software: you can redistribute it and/or modify 
+ * it under the terms of the GNU General Public License as published by 
+ * the Free Software Foundation, either version 3 of the License, or 
+ * (at your option) any later version. 
+ * 
+ * HeuristicLab is distributed in the hope that it will be useful, 
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * GNU General Public License for more details. 
+ * 
+ * You should have received a copy of the GNU General Public License 
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>. 
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.UserManagement.DataTransfer {
+  [DataContract]
+  public class Membership : UserManagementItem {
+    [DataMember]
+    public Guid ApplicationId { get; set; }
+
+    [DataMember]
+    public Guid UserId { get; set; }
+
+    [DataMember]
+    public string Password { get; set; }
+
+    [DataMember]
+    public int PasswordFormat { get; set; }
+
+    [DataMember]
+    public string PasswordSalt { get; set; }
+
+    [DataMember]
+    public string Email { get; set; }
+
+    [DataMember]
+    public string LoweredEmail { get; set; }
+
+    [DataMember]
+    public string PasswordQuestion { get; set; }
+
+    [DataMember]
+    public string PasswordAnswer { get; set; }
+
+    [DataMember]
+    public bool IsApproved { get; set; }
+
+    [DataMember]
+    public bool IsLockedOut { get; set; }
+
+    [DataMember]
+    public DateTime CreateDate { get; set; }
+
+    [DataMember]
+    public DateTime LastLoginDate { get; set; }
+
+    [DataMember]
+    public DateTime LastPasswordChangedDate { get; set; }
+
+    [DataMember]
+    public DateTime LastLockoutDate { get; set; }
+
+    [DataMember]
+    public int FailedPasswordAttemptCount { get; set; }
+
+    [DataMember]
+    public DateTime FailedPasswordAttemptWindowStart { get; set; }
+
+    [DataMember]
+    public int FailedPasswordAnswerAttemptCount { get; set; }
+
+    [DataMember]
+    public DateTime FailedPasswordAnswerAttemptWindowStart { get; set; }
+
+    [DataMember]
+    public string Comment { get; set; }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Role.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Role.cs	(revision 6809)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/Role.cs	(revision 6810)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Runtime.Serialization;
 
@@ -27,6 +26,10 @@
   [DataContract]
   public class Role : UserManagementItem {
+
     [DataMember]
-    public Guid ApplicationId { get; set; }
+    public string RoleName { get; set; }
+
+    [DataMember]
+    public Application App { get; set; }
   }
 }
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/User.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/User.cs	(revision 6809)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/User.cs	(revision 6810)
@@ -27,8 +27,20 @@
   public class User : UserManagementItem {
     [DataMember]
-    public Guid ApplicationId { get; set; }
+    public string Comment { get; set; }
 
     [DataMember]
     public string Email { get; set; }
+
+    [DataMember]
+    public DateTime CreationDate { get; set; }
+
+    [DataMember]
+    public DateTime LastLoginDate { get; set; }
+
+    [DataMember]
+    public DateTime LastPasswordChangedDate { get; set; }
+
+    [DataMember]
+    public DateTime LastLockoutDate { get; set; }
 
     [DataMember]
@@ -39,17 +51,23 @@
 
     [DataMember]
-    public DateTime CreateDate { get; set; }
-
-    [DataMember]
-    public DateTime LastLoginDate { get; set; }
-
-    [DataMember]
-    public DateTime LastPasswordChangeDate { get; set; }
-
-    [DataMember]
-    public DateTime LastLockoutDate { get; set; }
+    public bool IsOnline { get; set; }
 
     [DataMember]
     public DateTime LastActivityDate { get; set; }
+
+    [DataMember]
+    public string PasswordQuestion { get; set; }
+
+    [DataMember]
+    public string ProviderName { get; set; }
+
+    [DataMember]
+    public object ProviderUserKey { get; set; }
+
+    [DataMember]
+    public string UserName { get; set; }
+
+    [DataMember]
+    public Application App { get; set; }
   }
 }
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/UserManagementItem.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/UserManagementItem.cs	(revision 6809)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/DataTransfer/UserManagementItem.cs	(revision 6810)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Runtime.Serialization;
 
@@ -26,12 +25,7 @@
   [DataContract]
   public class UserManagementItem {
-    [DataMember]
-    public Guid Id { get; set; }
 
-    [DataMember]
-    public string Name { get; set; }
 
-    [DataMember]
-    public string Description { get; set; }
+
   }
 }
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/HeuristicLab.Services.UserManagement.csproj
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/HeuristicLab.Services.UserManagement.csproj	(revision 6809)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/HeuristicLab.Services.UserManagement.csproj	(revision 6810)
@@ -11,4 +11,5 @@
     <RootNamespace>HeuristicLab.Services.UserManagement</RootNamespace>
     <AssemblyName>HeuristicLab.Services.UserManagement</AssemblyName>
+    <ProjectTypeGuids>{3D9AD99F-2412-4246-B90B-4EAA41C64699};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
@@ -42,4 +43,6 @@
     <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.ServiceModel" />
+    <Reference Include="System.Web" />
+    <Reference Include="System.Web.ApplicationServices" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -49,4 +52,8 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Convert.cs" />
+    <Compile Include="DataTransfer\Application.cs" />
+    <Compile Include="DataTransfer\Membership.cs" />
+    <Compile Include="UserManagementService.cs" />
     <Compile Include="DataTransfer\Role.cs" />
     <Compile Include="DataTransfer\User.cs" />
@@ -54,9 +61,24 @@
     <Compile Include="IUserManagementService.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <None Include="app.config" />
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
   </ItemGroup>
-  <ItemGroup />
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Services.UserManagement.DataAccess\3.3\HeuristicLab.Services.UserManagement.DataAccess.csproj">
+      <Project>{AB586CCE-F953-458F-9061-8E4B83FC90D6}</Project>
+      <Name>HeuristicLab.Services.UserManagement.DataAccess</Name>
+    </ProjectReference>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <ProjectExtensions>
+    <VisualStudio>
+      <FlavorProperties GUID="{3D9AD99F-2412-4246-B90B-4EAA41C64699}">
+        <WcfProjectProperties>
+          <AutoStart>False</AutoStart>
+        </WcfProjectProperties>
+      </FlavorProperties>
+    </VisualStudio>
+  </ProjectExtensions>
   <PropertyGroup>
     <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/IUserManagementService.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/IUserManagementService.cs	(revision 6809)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/IUserManagementService.cs	(revision 6810)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Net.Security;
@@ -29,19 +28,14 @@
   [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
   public interface IUserManagementService {
+
     #region User
     [OperationContract]
-    User GetUser(Guid id);
+    IEnumerable<User> GetUsers(Application application);
 
     [OperationContract]
-    IEnumerable<User> GetUsers();
+    User AddUser(User user);
 
     [OperationContract]
-    IEnumerable<User> GetUsersForApplication(Guid applicationId);
-
-    [OperationContract]
-    Guid AddUser(User user);
-
-    [OperationContract]
-    void DeleteUser(Guid id);
+    void DeleteUser(User user);
 
     [OperationContract]
@@ -49,14 +43,11 @@
 
     [OperationContract]
-    void SetRoleForUser(Guid roleId, Guid userId);
+    void AddUserToRole(Role role, User user);
 
     [OperationContract]
-    IEnumerable<User> GetUsersWithRole(Guid roleId);
+    void RemoveUserFromRole(Role role, User user);
 
     [OperationContract]
-    void RemoveRoleFromUser(Guid roleId, Guid userId);
-
-    [OperationContract]
-    bool HasUserRole(Guid userId, Guid roleId);
+    bool IsUserInRole(User user, Role role);
 
     [OperationContract]
@@ -66,14 +57,8 @@
     #region Role
     [OperationContract]
-    Role GetRole(Guid id);
+    IEnumerable<Role> GetRoles(Application application);
 
     [OperationContract]
-    IEnumerable<Role> GetRoles();
-
-    [OperationContract]
-    IEnumerable<Role> GetRolesForApplication(Guid applicationId);
-
-    [OperationContract]
-    Guid AddRole(Role role);
+    Role AddRole(Role role);
 
     [OperationContract]
@@ -81,8 +66,33 @@
 
     [OperationContract]
-    void DeleteRole(Guid id);
+    void DeleteRole(Role role);
 
     [OperationContract]
-    IEnumerable<Role> GetUserRoles(Guid userId);
+    IEnumerable<Role> GetUserRoles(User user);
+    #endregion
+
+    #region Application
+    [OperationContract]
+    IEnumerable<Application> GetApplications();
+
+    [OperationContract]
+    IEnumerable<User> GetApplicationUsers(Application application);
+
+    [OperationContract]
+    Application AddApplication(Application application);
+
+    [OperationContract]
+    void UpdateApplication(Application application);
+
+    [OperationContract]
+    void DeleteApplication(Application application);
+    #endregion
+
+    #region Client specific methods
+    [OperationContract]
+    bool CheckUserExists(string application, string userName, string password);
+
+    [OperationContract]
+    bool GetUser(string application, string userName, string password);
     #endregion
   }
Index: /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/UserManagementService.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/UserManagementService.cs	(revision 6810)
+++ /branches/ClientUserManagement/HeuristicLab.Services.UserManagement/3.3/UserManagementService.cs	(revision 6810)
@@ -0,0 +1,112 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.ServiceModel;
+
+namespace HeuristicLab.Services.UserManagement {
+  [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
+  public class UserManagementService : IUserManagementService {
+
+    #region IUserManagementService Members
+
+    public System.Collections.Generic.IEnumerable<DataTransfer.User> GetUsers(DataTransfer.Application application) {
+      throw new System.NotImplementedException();
+    }
+
+    public DataTransfer.User AddUser(DataTransfer.User user) {
+      throw new System.NotImplementedException();
+    }
+
+    public void DeleteUser(DataTransfer.User user) {
+      throw new System.NotImplementedException();
+    }
+
+    public void UpdateUser(DataTransfer.User user) {
+      throw new System.NotImplementedException();
+    }
+
+    public void AddUserToRole(DataTransfer.Role role, DataTransfer.User user) {
+      throw new System.NotImplementedException();
+    }
+
+    public void RemoveUserFromRole(DataTransfer.Role role, DataTransfer.User user) {
+      throw new System.NotImplementedException();
+    }
+
+    public bool IsUserInRole(DataTransfer.User user, DataTransfer.Role role) {
+      throw new System.NotImplementedException();
+    }
+
+    public DataTransfer.User ResetPassword(string applicationName, string userName, string password) {
+      throw new System.NotImplementedException();
+    }
+
+    public System.Collections.Generic.IEnumerable<DataTransfer.Role> GetRoles(DataTransfer.Application application) {
+      throw new System.NotImplementedException();
+    }
+
+    public DataTransfer.Role AddRole(DataTransfer.Role role) {
+      throw new System.NotImplementedException();
+    }
+
+    public void UpdateRole(DataTransfer.Role role) {
+      throw new System.NotImplementedException();
+    }
+
+    public void DeleteRole(DataTransfer.Role role) {
+      throw new System.NotImplementedException();
+    }
+
+    public System.Collections.Generic.IEnumerable<DataTransfer.Role> GetUserRoles(DataTransfer.User user) {
+      throw new System.NotImplementedException();
+    }
+
+    public System.Collections.Generic.IEnumerable<DataTransfer.Application> GetApplications() {
+      throw new System.NotImplementedException();
+    }
+
+    public System.Collections.Generic.IEnumerable<DataTransfer.User> GetApplicationUsers(DataTransfer.Application application) {
+      throw new System.NotImplementedException();
+    }
+
+    public DataTransfer.Application AddApplication(DataTransfer.Application application) {
+      throw new System.NotImplementedException();
+    }
+
+    public void UpdateApplication(DataTransfer.Application application) {
+      throw new System.NotImplementedException();
+    }
+
+    public void DeleteApplication(DataTransfer.Application application) {
+      throw new System.NotImplementedException();
+    }
+
+    public bool CheckUserExists(string application, string userName, string password) {
+      throw new System.NotImplementedException();
+    }
+
+    public bool GetUser(string application, string userName, string password) {
+      throw new System.NotImplementedException();
+    }
+
+    #endregion
+  }
+}
